import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Brand, BrandParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询品牌
 */
export async function pageBrand(params: BrandParam) {
  const res = await request.get<ApiResult<PageResult<Brand>>>(
    MODULES_API_URL + '/shop/brand/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询品牌列表
 */
export async function listBrand(params?: BrandParam) {
  const res = await request.get<ApiResult<Brand[]>>(
    MODULES_API_URL + '/shop/brand',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加品牌
 */
export async function addBrand(data: Brand) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/brand',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改品牌
 */
export async function updateBrand(data: Brand) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/brand',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除品牌
 */
export async function removeBrand(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/brand/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除品牌
 */
export async function removeBatchBrand(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/brand/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询品牌
 */
export async function getBrand(id: number) {
  const res = await request.get<ApiResult<Brand>>(
    MODULES_API_URL + '/shop/brand/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
